#!/bin/sh
#
#
# OpenStack Neutron Server (neutron-server)
#
# Description:  Manages an OpenStack Neutron Server (neutron-server) process as
#               an HA resource
#
# Authors:      Emilien Macchi
# Mainly inspired by the Neutron API resource agent written by Sebastien Han:
# http://goo.gl/s8hOU Which is also inspired by the Glance API resource agent
# written by Martin Gerhard Loschwitz from Hastexo: http://goo.gl/whLpr
#
# Support:      openstack@lists.openstack.org
# License:      Apache Software License (ASL) 2.0
#
#
# See usage() function below for more details ...
#
# OCF instance parameters:
#   OCF_RESKEY_binary
#   OCF_RESKEY_config
#   OCF_RESKEY_plugin_config
#   OCF_RESKEY_user
#   OCF_RESKEY_pid
#   OCF_RESKEY_additional_parameters
# OCF deprecated parameters:
#   OCF_RESKEY_os_username
#   OCF_RESKEY_os_password
#   OCF_RESKEY_os_tenant_name
#   OCF_RESKEY_keystone_get_token_url
#######################################################################
# Initialization:

: ${OCF_FUNCTIONS_DIR=${OCF_ROOT}/lib/heartbeat}
. ${OCF_FUNCTIONS_DIR}/ocf-shellfuncs

#######################################################################

# Fill in some defaults if no values are specified

OCF_RESKEY_binary_default="neutron-server"
OCF_RESKEY_config_default="/etc/neutron/neutron.conf"
OCF_RESKEY_plugin_config_default=\
"/etc/neutron/plugins/openvswitch/ovs_neutron_plugin.ini"
OCF_RESKEY_user_default="neutron"
OCF_RESKEY_pid_default="$HA_RSCTMP/$OCF_RESOURCE_INSTANCE.pid"
OCF_RESKEY_url_default="http://127.0.0.1:9696"

: ${OCF_RESKEY_binary=${OCF_RESKEY_binary_default}}
: ${OCF_RESKEY_config=${OCF_RESKEY_config_default}}
: ${OCF_RESKEY_plugin_config=${OCF_RESKEY_plugin_config_default}}
: ${OCF_RESKEY_user=${OCF_RESKEY_user_default}}
: ${OCF_RESKEY_pid=${OCF_RESKEY_pid_default}}
: ${OCF_RESKEY_url=${OCF_RESKEY_url_default}}

#######################################################################

usage() {
    cat <<UEND
        usage: $0 (start|stop|validate-all|meta-data|status|monitor)

        $0 manages an OpenStack Neutron Server (neutron-server) process as an HA resource

        The 'start' operation starts the Neutron Server service.
        The 'stop' operation stops the Neutron Server service.
        The 'validate-all' operation reports whether the parameters are valid
        The 'meta-data' operation reports this RA's meta-data information
        The 'status' operation reports whether the Neutron Server service is running
        The 'monitor' operation reports whether the Neutron Server service seems to be working

UEND
}

meta_data() {
    cat <<END
<?xml version="1.0"?>
<!DOCTYPE resource-agent SYSTEM "ra-api-1.dtd">
<resource-agent name="neutron-server">
<version>1.0</version>

<longdesc lang="en">
Resource agent for the OpenStack Neutron Server (neutron-server)
May manage a neutron-server instance or a clone set that
creates a distributed neutron-server cluster.
</longdesc>
<shortdesc lang="en">Manages the OpenStack Neutron Server (neutron-server)</shortdesc>
<parameters>

<parameter name="binary" unique="0" required="0">
<longdesc lang="en">
Location of the OpenStack Neutron Server server binary (neutron-server)
</longdesc>
<shortdesc lang="en">OpenStack Neutron Server server binary (neutron-server)</shortdesc>
<content type="string" default="${OCF_RESKEY_binary_default}" />
</parameter>

<parameter name="config" unique="0" required="0">
<longdesc lang="en">
Location of the OpenStack Neutron Server (neutron-server) configuration file
</longdesc>
<shortdesc lang="en">OpenStack Neutron Server (neutron-server) config file</shortdesc>
<content type="string" default="${OCF_RESKEY_config_default}" />
</parameter>

<parameter name="plugin_config" unique="0" required="0">
<longdesc lang="en">
Location of the OpenStack Default Plugin (Open-vSwitch) configuration file
</longdesc>
<shortdesc lang="en">OpenStack OVS (neutron-ovs) config file</shortdesc>
<content type="string" default="${OCF_RESKEY_plugin_config_default}" />
</parameter>

<parameter name="user" unique="0" required="0">
<longdesc lang="en">
User running OpenStack Neutron Server (neutron-server)
</longdesc>
<shortdesc lang="en">OpenStack Neutron Server (neutron-server) user</shortdesc>
<content type="string" default="${OCF_RESKEY_user_default}" />
</parameter>

<parameter name="pid" unique="0" required="0">
<longdesc lang="en">
The pid file to use for this OpenStack Neutron Server (neutron-server) instance
</longdesc>
<shortdesc lang="en">OpenStack Neutron Server (neutron-server) pid file</shortdesc>
<content type="string" default="${OCF_RESKEY_pid_default}" />
</parameter>

<parameter name="url" unique="0" required="0">
<longdesc lang="en">
The default URL to use for monitoring this instance (neutron-server) via curl. Important note: the monitor function doesn't accept http return code different than 200, for instance redirection code will generate an error. Don't forget the '/' at the end of your url endpoint. For example http://127.0.0.1:9696/v1.1 won't work and http://127.0.0.1:9696/v1.1/ will.
</longdesc>
<shortdesc lang="en">OpenStack Neutron API (neutron-server) monitor url</shortdesc>
<content type="string" default="${OCF_RESKEY_url_default}" />
</parameter>

<parameter name="keystone_get_token_url" unique="0" required="0">
<longdesc lang="en">
This parameter is DEPRECATED, you can specify it but it won't be used.
The default URL to use to acquire a Neutron API (neutron-server) token for monitoring this instance
of OpenStack Neutron API (neutron-server)
</longdesc>
<shortdesc lang="en">DEPRECATED! OpenStack Neutron API (neutron-server) url</shortdesc>
<content type="string" default="${OCF_RESKEY_keystone_get_token_url_default}" />
</parameter>

<parameter name="os_username" unique="0" required="0">
<longdesc lang="en">
This parameter is DEPRECATED, you can specify it but it won't be used.
The username to use when connecting with Neutron API (neutron-server) for monitoring purposes
</longdesc>
<shortdesc lang="en">DEPRECATED! Neutron API (neutron-server) monitoring login</shortdesc>
<content type="string" />
</parameter>

<parameter name="os_password" unique="0" required="0">
<longdesc lang="en">
This parameter is DEPRECATED, you can specify it but it won't be used.
The password to use when connecting Neutron API (neutron-server) for monitoring purposes
</longdesc>
<shortdesc lang="en">DEPRECATED! Neutron API (neutron-server) monitoring password</shortdesc>
<content type="string" />
</parameter>

<parameter name="os_tenant_name" unique="0" required="0">
<longdesc lang="en">
This parameter is DEPRECATED, you can specify it but it won't be used.
The tenant to use when connecting Neutron API (neutron-server) for monitoring purposes
</longdesc>
<shortdesc lang="en">DEPRECATED! Neutron API (neutron-server) monitoring tenant</shortdesc>
<content type="string" />
</parameter>

<parameter name="additional_parameters" unique="0" required="0">
<longdesc lang="en">
Additional parameters to pass on to the OpenStack Neutron Server (neutron-server)
</longdesc>
<shortdesc lang="en">Additional parameters for neutron-server</shortdesc>
<content type="string" />
</parameter>

</parameters>

<actions>
<action name="start" timeout="20" />
<action name="stop" timeout="20" />
<action name="status" timeout="20" />
<action name="monitor" timeout="10" interval="5" />
<action name="validate-all" timeout="5" />
<action name="meta-data" timeout="5" />
</actions>
</resource-agent>
END
}

#######################################################################
# Functions invoked by resource manager actions

neutron_server_validate() {
    local rc

    check_binary $OCF_RESKEY_binary
    check_binary curl
    check_binary tr
    check_binary grep
    check_binary cut
    check_binary head

    # A config file on shared storage that is not available
    # during probes is OK.
    if [ ! -f $OCF_RESKEY_config ]; then
        if ! ocf_is_probe; then
            ocf_log err "Config $OCF_RESKEY_config doesn't exist"
            return $OCF_ERR_INSTALLED
        fi
        ocf_log_warn "Config $OCF_RESKEY_config not available during a probe"
    fi

    getent passwd $OCF_RESKEY_user >/dev/null 2>&1
    rc=$?
    if [ $rc -ne 0 ]; then
        ocf_log err "User $OCF_RESKEY_user doesn't exist"
        return $OCF_ERR_INSTALLED
    fi

    true
}

neutron_server_status() {
    local pid
    local rc

    if [ ! -f $OCF_RESKEY_pid ]; then
        ocf_log info "OpenStack Neutron Server (neutron-server) is not running"
        return $OCF_NOT_RUNNING
    else
        pid=`cat $OCF_RESKEY_pid`
    fi

    ocf_run -warn kill -s 0 $pid
    rc=$?
    if [ $rc -eq 0 ]; then
        return $OCF_SUCCESS
    else
        ocf_log info "Old PID file found, but OpenStack Neutron Server" \
            "(neutron-server) is not running"
        return $OCF_NOT_RUNNING
    fi
}

neutron_server_monitor() {
    local rc
    local http_code

    neutron_server_status
    rc=$?

    # If status returned anything but success, return that immediately
    if [ $rc -ne $OCF_SUCCESS ]; then
        return $rc
    fi
    # Check the response code of the "List API versions" call.
    # If it's 200, we consider neutron-server is properly running.
    if [ -n "$OCF_RESKEY_url" ]; then
        http_code=`curl --silent --write-out %{http_code} --output /dev/null \
            -X GET $OCF_RESKEY_url`
        rc=$?
        if [ $rc -ne 0 ] || [ $http_code -ne 200 ]; then
            ocf_log err "Failed to connect to the OpenStack Neutron API" \
                "(neutron-server): $rc and $http_code"
            return $OCF_NOT_RUNNING
        fi
    fi

    ocf_log debug "OpenStack Neutron Server (neutron-server) monitor succeeded"
    return $OCF_SUCCESS
}

neutron_server_start() {
    local rc

    neutron_server_status
    rc=$?
    if [ $rc -eq $OCF_SUCCESS ]; then
        ocf_log info "OpenStack Neutron Server (neutron-server) already" \
            "running"
        return $OCF_SUCCESS
    fi

    # run the actual neutron-server daemon with correct configurations files
    # (server + plugin)
    # Don't use ocf_run as we're sending the tool's output # straight to
    # /dev/null anyway and using ocf_run would break stdout-redirection here.
    su ${OCF_RESKEY_user} -s /bin/sh -c "${OCF_RESKEY_binary} \
        --config-file=$OCF_RESKEY_config \
        --config-file=$OCF_RESKEY_plugin_config \
        --log-file=/var/log/neutron/server.log \
        $OCF_RESKEY_additional_parameters"' >> /dev/null 2>&1 & echo $!' \
        > $OCF_RESKEY_pid

    # Spin waiting for the server to come up.
    # Let the CRM/LRM time us out if required
    while true; do
    neutron_server_monitor
    rc=$?
    [ $rc -eq $OCF_SUCCESS ] && break
    if [ $rc -ne $OCF_NOT_RUNNING ]; then
        ocf_log err "OpenStack Neutron Server (neutron-server) start failed"
        exit $OCF_ERR_GENERIC
    fi
    sleep 1
    done

    ocf_log info "OpenStack Neutron Server (neutron-server) started"
    return $OCF_SUCCESS
}

neutron_server_stop() {
    local rc
    local pid

    neutron_server_status
    rc=$?
    if [ $rc -eq $OCF_NOT_RUNNING ]; then
        ocf_log info "OpenStack Neutron Server (neutron-server) already" \
            "stopped"
        return $OCF_SUCCESS
    fi

    # Try SIGTERM
    pid=`cat $OCF_RESKEY_pid`
    ocf_run kill -s TERM $pid
    rc=$?
    if [ $rc -ne 0 ]; then
        ocf_log err "OpenStack Neutron Server (neutron-server) couldn't be" \
            "stopped"
        exit $OCF_ERR_GENERIC
    fi

    # stop waiting
    shutdown_timeout=15
    if [ -n "$OCF_RESKEY_CRM_meta_timeout" ]; then
        shutdown_timeout=$((($OCF_RESKEY_CRM_meta_timeout/1000)-5))
    fi
    count=0
    while [ $count -lt $shutdown_timeout ]; do
        neutron_server_status
        rc=$?
        if [ $rc -eq $OCF_NOT_RUNNING ]; then
            break
        fi
        count=`expr $count + 1`
        sleep 1
        ocf_log debug "OpenStack Neutron Server (neutron-server) still" \
            "hasn't stopped yet. Waiting ..."
    done

    neutron_server_status
    rc=$?
    if [ $rc -ne $OCF_NOT_RUNNING ]; then
        # SIGTERM didn't help either, try SIGKILL
        ocf_log info "OpenStack Neutron Server (neutron-server) failed to" \
            "stop after ${shutdown_timeout}s using SIGTERM. Trying SIGKILL ..."
        ocf_run kill -s KILL $pid
    fi

    ocf_log info "OpenStack Neutron Server (neutron-server) stopped"

    rm -f $OCF_RESKEY_pid

    return $OCF_SUCCESS
}

#######################################################################

case "$1" in
    meta-data)
        meta_data
        exit $OCF_SUCCESS
        ;;
    usage|help)
        usage
        exit $OCF_SUCCESS
        ;;
esac

# Anything except meta-data and help must pass validation
neutron_server_validate || exit $?

# What kind of method was invoked?
case "$1" in
    start)
        neutron_server_start
        ;;
    stop)
        neutron_server_stop
        ;;
    status)
        neutron_server_status
        ;;
    monitor)
        neutron_server_monitor
        ;;
    validate-all)
        ;;
    *)
        usage
        exit $OCF_ERR_UNIMPLEMENTED
        ;;
esac
